package cn.pluss.platform.controller.upload;

import cn.pluss.platform.util.OssOperatUtil;
import org.apache.tomcat.util.http.fileupload.FileItemIterator;
import org.apache.tomcat.util.http.fileupload.FileItemStream;
import org.apache.tomcat.util.http.fileupload.disk.DiskFileItemFactory;
import org.apache.tomcat.util.http.fileupload.servlet.ServletFileUpload;

import javax.servlet.http.HttpServletRequest;
import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * UEditor文件上传辅助类
 *
 * @author yuchen
 * @Description
 */
public class Uploader {
    // 输出文件地址
    private String url = "";
    // 上传文件名
    private String fileName = "";
    // 状态
    private String state = "";
    // 文件类型
    private String type = "";
    // 原始文件名
    private String originalName = "";
    // 文件大小
    private long size = 0;

    private HttpServletRequest request = null;
    private String title = "";

    // 保存路径
    private String savePath = "upload";
    // 文件允许格式
    private String[] allowFiles = {".rar", ".doc", ".docx", ".zip", ".pdf", ".txt", ".swf", ".wmv", ".gif", ".png", ".jpg", ".jpeg", ".bmp"};
    // 文件大小限制，单位KB
    private int maxSize = 10000;

    private HashMap<String, String> errorInfo = new HashMap<>();

    public Uploader(HttpServletRequest request) {
        this.request = request;
        HashMap<String, String> tmp = this.errorInfo;
        tmp.put("SUCCESS", "SUCCESS"); //默认成功
        tmp.put("NOFILE", "未包含文件上传域");
        tmp.put("TYPE", "不允许的文件格式");
        tmp.put("SIZE", "文件大小超出限制");
        tmp.put("ENTYPE", "请求类型ENTYPE错误");
        tmp.put("REQUEST", "上传请求异常");
        tmp.put("IO", "IO异常");
        tmp.put("DIR", "目录创建失败");
        tmp.put("UNKNOWN", "未知错误");

    }

    @SuppressWarnings("unused")
    // 存到本机
//	public void upload() throws Exception {
//		boolean isMultipart = ServletFileUpload.isMultipartContent(this.request);
//		if (!isMultipart) {
//			this.state = this.errorInfo.get("NOFILE");
//			return;
//		}
//		DiskFileItemFactory dff = new DiskFileItemFactory();
//		savePath="/home/syb/resources/images/upload";
//
//		Properties prop = System.getProperties();
//        String os = prop.getProperty("os.name");
//        if(os.startsWith("win") || os.startsWith("Win")){
//			// windows目录
//        	savePath="D:\\Dev\\SVN\\Java\\pluss\\media\\resources\\manage\\upload";
//        }
//
//		dff.setRepository(new File(savePath));
//		try {
//			ServletFileUpload sfu = new ServletFileUpload(dff);
//			sfu.setSizeMax(this.maxSize * 1024*1024);
//			sfu.setHeaderEncoding("utf-8");
//			FileItemIterator fii = sfu.getItemIterator(this.request);
//			while (fii.hasNext()) {
//				FileItemStream fis = fii.next();
//				if (!fis.isFormField()) {
//					this.originalName = fis.getName().substring(fis.getName().lastIndexOf(System.getProperty("file.separator")) + 1);
//					if (!this.checkFileType(this.originalName)) {
//						this.state = this.errorInfo.get("TYPE");
//						continue;
//					}
//					this.fileName = this.getName(this.originalName);
//					this.type = this.getFileExt(this.fileName);
//					this.url = savePath + "/" + this.fileName;
//
//					BufferedInputStream in = new BufferedInputStream(fis.openStream());
//					File file = new File(this.url);
//					FileOutputStream out = new FileOutputStream(file);
//					BufferedOutputStream output = new BufferedOutputStream(out);
//					Streams.copy(in, output, true);
//
//					this.state=this.errorInfo.get("SUCCESS");
//					//UE中只会处理单张上传，完成后即退出
//					url="https://www.shouyinbei.net/resources/images/upload"+ "/" + this.fileName;
//					 if(os.startsWith("win") || os.startsWith("Win")){
//							// windows目录
//						 url="http://127.0.0.1/resources/manage/upload"+ "/" + this.fileName;
//				     }else {
//				    	 Runtime.getRuntime().exec("chmod -R 777 /home/syb/resources/");
//				     }
//					break;
//				} else {
//					String fname = fis.getFieldName();
//					//只处理title，其余表单请自行处理
//					if(!"pictitle".equals(fname)){
//						continue;
//					}
//                    BufferedInputStream in = new BufferedInputStream(fis.openStream());
//                    BufferedReader reader = new BufferedReader(new InputStreamReader(in));
//                    StringBuffer result = new StringBuffer();
//                    while (reader.ready()) {
//                        result.append((char)reader.read());
//                    }
//                    this.title = new String(result.toString().getBytes(),"utf-8");
//                    reader.close();
//
//				}
//			}
//		} catch (Exception e) {
//			this.state = this.errorInfo.get("UNKNOWN");
//			System.out.println(e.toString());
//		}
//	}

    /**
     * 内容编辑器的图片文件上传等修改为oss上传
     */
    public void upload() {
        boolean isMultipart = ServletFileUpload.isMultipartContent(this.request);
        if (!isMultipart) {
            this.state = this.errorInfo.get("NOFILE");
            return;
        }
        DiskFileItemFactory dff = new DiskFileItemFactory();
//        savePath = "/home/syb/resources/images/upload";
//
//        Properties prop = System.getProperties();
//        String os = prop.getProperty("os.name");
//        if (os.startsWith("win") || os.startsWith("Win")) {
//            // windows目录
//            savePath = "D:\\Dev\\SVN\\Java\\pluss\\media\\resources\\manage\\upload";
//        }
//
//        File dir = new File(savePath);
//        dff.setRepository(dir);
//        if (!dir.exists()) {
//            dir.mkdirs();
//        }

        try {
            ServletFileUpload sfu = new ServletFileUpload(dff);
            sfu.setSizeMax(this.maxSize * 1024 * 1024);
            sfu.setHeaderEncoding("utf-8");
            FileItemIterator fii = sfu.getItemIterator(this.request);
            while (fii.hasNext()) {
                FileItemStream fis = fii.next();
                if (!fis.isFormField()) {
                    this.originalName = fis.getName().substring(fis.getName().lastIndexOf(System.getProperty("file.separator")) + 1);
                    if (!this.checkFileType(this.originalName)) {
                        this.state = this.errorInfo.get("TYPE");
                        continue;
                    }
                    this.fileName = this.getName(this.originalName);
                    this.type = this.getFileExt(this.fileName);
                    this.url = savePath + "/" + this.fileName;

                    originalName = fis.getName().substring(fis.getName().lastIndexOf(System.getProperty("file.separator")) + 1);
                    this.state = this.errorInfo.get("SUCCESS");
                    try (InputStream is = fis.openStream()) {
                        originalName = UUID.randomUUID().toString().replace("-", "");
                        url = OssOperatUtil.upload(is, fileName, originalName);
                    } catch (Exception e) {
                        System.out.println("图片上传错误");
                    }
                    break;
                } else {
                    String fname = fis.getFieldName();
                    //只处理title，其余表单请自行处理
                    if (!"pictitle".equals(fname)) {
                        continue;
                    }
                    BufferedInputStream in = new BufferedInputStream(fis.openStream());
                    BufferedReader reader = new BufferedReader(new InputStreamReader(in));
                    StringBuffer result = new StringBuffer();
                    while (reader.ready()) {
                        result.append((char) reader.read());
                    }
                    this.title = new String(result.toString().getBytes(), "utf-8");
                    reader.close();

                }
            }
        } catch (Exception e) {
            this.state = this.errorInfo.get("UNKNOWN");
            System.out.println(e.toString());
        }


//		try {
//			ServletFileUpload sfu = new ServletFileUpload(dff);
//			sfu.setSizeMax(this.maxSize * 1024*1024);
//			sfu.setHeaderEncoding("utf-8");
//			FileItemIterator fii = sfu.getItemIterator(this.request);
//			while (fii.hasNext()) {
//				FileItemStream fis = fii.next();
//				originalName = fis.getName().substring(fis.getName().lastIndexOf(System.getProperty("file.separator")) + 1);
//				try (BufferedInputStream is = new BufferedInputStream(fis.openStream())) {
//					fileName = UUID.randomUUID().toString().replace("-", "");
//					url = OssOperatUtil.upload(is, fileName, originalName);
//				} catch (Exception e) {
//					System.out.println("图片上传错误");
//				}
//			}
//		} catch (Exception e) {
//			this.state = this.errorInfo.get("UNKNOWN");
//			System.out.println(e.toString());
//		}
    }

    /**
     * 接受并保存以base64格式上传的文件
     *
     * @param fieldName
     */
    public void uploadBase64(String fieldName) {
        String savePath = this.getFolder(this.savePath);
        String base64Data = this.request.getParameter(fieldName);
        this.fileName = this.getName("test.png");
        this.url = savePath + "/" + this.fileName;
        Base64.Decoder decoder = Base64.getDecoder();
        try {
            File outFile = new File(this.getPhysicalPath(this.url));
            OutputStream ro = new FileOutputStream(outFile);
            byte[] b = decoder.decode(base64Data);
            for (int i = 0; i < b.length; ++i) {
                if (b[i] < 0) {
                    b[i] += 256;
                }
            }
            ro.write(b);
            ro.flush();
            ro.close();
            this.state = this.errorInfo.get("SUCCESS");
        } catch (Exception e) {
            this.state = this.errorInfo.get("IO");
        }
    }

    /**
     * 文件类型判断
     *
     * @param fileName
     * @return
     */
    private boolean checkFileType(String fileName) {
        Iterator<String> type = Arrays.asList(this.allowFiles).iterator();
        while (type.hasNext()) {
            String ext = type.next();
            if (fileName.toLowerCase().endsWith(ext)) {
                return true;
            }
        }
        return false;
    }

    /**
     * 获取文件扩展名
     *
     * @return string
     */
    private String getFileExt(String fileName) {
        return fileName.substring(fileName.lastIndexOf("."));
    }

    /**
     * 依据原始文件名生成新文件名
     *
     * @return
     */
    private String getName(String fileName) {
        Random random = new Random();
        return this.fileName = "" + random.nextInt(10000)
                + System.currentTimeMillis() + this.getFileExt(fileName);
    }

    /**
     * 根据字符串创建本地目录 并按照日期建立子目录返回
     *
     * @param path
     * @return
     */
    private String getFolder(String path) {
        SimpleDateFormat formater = new SimpleDateFormat("yyyyMMdd");
        path += "/" + formater.format(new Date());
        File dir = new File(this.getPhysicalPath(path));
        if (!dir.exists()) {
            try {
                dir.mkdirs();
            } catch (Exception e) {
                this.state = this.errorInfo.get("DIR");
                return "";
            }
        }
        return path;
    }

    /**
     * 根据传入的虚拟路径获取物理路径
     *
     * @param path
     * @return
     */
    private String getPhysicalPath(String path) {
        String servletPath = this.request.getServletPath();
        String realPath = this.request.getSession().getServletContext()
                .getRealPath(servletPath);
        return new File(realPath).getParent() + "/" + path;
    }

    public void setSavePath(String savePath) {
        this.savePath = savePath;
    }

    public void setAllowFiles(String[] allowFiles) {
        this.allowFiles = allowFiles;
    }

    public void setMaxSize(int size) {
        this.maxSize = size;
    }

    public long getSize() {
        return this.size;
    }

    public String getUrl() {
        return this.url;
    }

    public String getFileName() {
        return this.fileName;
    }

    public String getState() {
        return this.state;
    }

    public String getTitle() {
        return this.title;
    }

    public String getType() {
        return this.type;
    }

    public String getOriginalName() {
        return this.originalName;
    }
}
